'''
Created on Aug 18, 2011

@author: maemo
'''

import sys
import gtk
import hildon
import time 
from Options import OptionsPanel
from Home import HomePanel
from Help import HelpPanel
from ConfirmationWork import ConfirmatonWork
from Notification import Notification
from accelerometer import  Accelerometer
from EmergencyNumber import EmergencyNumberPanel
from ImportantNumbers import ImportantNumbersPanel
from Player import Player
from Intro import Intro
import pygame.mixer
import random

def hello():
    print "hello, world"

class Root:
    
    def __init__(self):
        self.options = OptionsPanel(self)
        self.home = HomePanel(self)
        self.confirmationWork = ConfirmatonWork(self)
        self.notification = Notification(self)
        self.emergency_settings = EmergencyNumberPanel(self)
        self.important_settings = ImportantNumbersPanel(self)
        self.help = HelpPanel(self)
        self.intro = Intro(self)
        
        self.rootLayout = gtk.VBox(False, 10)
        self.currentPage = self.options
        self.lastPage = self.currentPage
        
        program = hildon.Program.get_instance()
        self.win = hildon.Window()
        
        
    def playSound(self, music):
        player = Player()
        #sound = player.Load("button-4.wav")
        sound = player.Load(music)
        player.Play(sound)
        
        
    def goToConfirmationWork(self):
        print "ConfirmationWork"
        self.rootLayout.remove(self.currentPage.returnPanel())
        self.currentPage = self.confirmationWork
        self.rootLayout.add(self.currentPage.returnPanel())
        self.win.show_all()
        
    
    def goToHome(self):
        num = random.randrange(1,4)
        if num == 1: 
            self.playSound("Alex_settings_16.wav")
        elif num == 2: 
            self.playSound("Camilo_settings_16.wav")
        elif num == 3: 
            self.playSound("Mihai_settings_16.wav")
        self.rootLayout.remove(self.currentPage.returnPanel())
        self.currentPage = self.home
        self.rootLayout.add(self.currentPage.returnPanel())
        self.win.show_all()
        
    def goToEmergencyNumberPanel(self):
        self.rootLayout.remove(self.currentPage.returnPanel())
        self.currentPage = self.emergency_settings
        self.rootLayout.add(self.emergency_settings.returnPanel())
        self.win.show_all()    
        
    def goToImportantNumbersPanel(self):
        self.rootLayout.remove(self.currentPage.returnPanel())
        self.currentPage = self.important_settings
        self.rootLayout.add(self.important_settings.returnPanel())
        self.win.show_all() 
        
    def goToHelp(self):
        self.rootLayout.remove(self.currentPage.returnPanel())
        self.currentPage = self.help
        self.rootLayout.add(self.currentPage.returnPanel())
        self.win.show_all()
        
    def goToOptions(self):
        self.rootLayout.remove(self.currentPage.returnPanel())
        self.currentPage = self.options
        self.rootLayout.add(self.currentPage.returnPanel())
        self.win.show_all()  
     
        
    def goToBlank(self):
        print "Blank"
        self.rootLayout.remove(self.currentPage.returnPanel())
        #self.win.show_all()
        self.win.hide()
        print >>sys.stderr, "after hide"
        gtk.main_iteration_do(False)
        self.readAccelerometerData()
        
    def readAccelerometerData(self):
        #we create the loop for the accelerometer
        #loop goes here....
        print >>sys.stderr, "read"
        
        self.accel = Accelerometer()
        self.previousReading = self.accel.calculateCoords()
        self.currentReading = 0;
        
        while True:
            self.currentReading = self.previousReading - self.accel.calculateCoords()
            gtk.main_iteration_do(False)
            self.previousReading = self.accel.calculateCoords()
            if (self.currentReading > 700 or self.currentReading < -700):                
                break
        
        #condition trigger
        self.guyFeltDown()
        
        
    def guyFeltDown(self):
        
        num = random.randrange(1,4)
        if num == 1: 
            self.playSound("Alex_notification_16.wav")
        elif num == 2: 
            self.playSound("Camilo_notification_16.wav")
        elif num == 3: 
            self.playSound("Mihai_notification_16.wav")
        
        #pygame.mixer.pre_init(44100, 16, 2, 4096)
        #pygame.mixer.init()        
        #channel1 = pygame.mixer.Sound('Alex_emergency.wav') # .ogg work in IDLE
                                                        # as well
        
        #channel1.play()
        self.rootLayout.remove(self.currentPage.returnPanel())
        self.currentPage = self.notification
        self.rootLayout.add(self.currentPage.returnPanel())
        self.win.show_all()
        gtk.main_iteration_do(False)
        gtk.main_iteration_do(False)
        gtk.main_iteration_do(False)
        time.sleep(2)
        
        self.readAccelerometerData()
            
    
    def start(self):
        self.currentPage = self.intro
        self.rootLayout.add(self.intro.returnPanel())
        self.win.add(self.rootLayout)
        self.win.connect("delete_event", gtk.main_quit)
        self.win.show_all()
        num = random.randrange(1,4)
        '''
        if num == 1: 
            self.playSound("Alex_settings_16.wav")
        elif num == 2: 
            self.playSound("Camilo_settings_16.wav")
        elif num == 3: 
            self.playSound("Mihai_settings_16.wav")
        '''
        gtk.main_iteration_do(False)
        
        self.readAccelerometerData()
        
        gtk.main_iteration_do(False)
        